package com.test.model;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import javax.persistence.Entity;

@Entity(name = "com.test.virtual.model22.MyContact")
public class Contact
{
	private String name = null;
	private Address mainAddress = null;
	private List<Address> addresses = null;

	public Contact(String name)
	{
		this.name = name;
	}

	public Contact()
	{
	}

	public String getName()
	{
		return name;
	}

	public void setName(String name)
	{
		this.name = name;
	}

	public List<Address> getAddresses()
	{
		final List<Address> result = new ArrayList<Address>();
		if (mainAddress != null)
		{
			result.add(mainAddress);
		}
		if (addresses != null)
		{
			result.addAll(addresses);
		}
		return Collections.unmodifiableList(result);
	}

	public void addAddress(Address address)
	{
		if (addresses == null)
		{
			addresses = new ArrayList<Address>();
		}
		addresses.add(address);
		updateMainAddress();
	}

	private void updateMainAddress()
	{
		if (!addresses.isEmpty())
		{
			mainAddress = addresses.remove(0);
		}
	}
}